import Qt 4.7

Rectangle {
    width: 200
    height: 200
    Text {
        z: 0.1
        id: someText
        x: 66
        text: "Hello World"

        // Property value source animation is automatically run
        NumberAnimation on y {
            from: 0
            to: 93
            duration: 2000
        }

        // Signal-bound animation is run when signal is emitted
        MouseArea {
            anchors.fill: parent
            onClicked: NumberAnimation {
                target: someText
                property: "x"
                to: redRect.x
            }
        }
    }

    // Standalone animation needs to be explicitly started
    // In this case it is started from the mouse signal handler
    NumberAnimation {
        id: standalone
        target: redRect
        property: "x"
    }

    MouseArea {
        anchors.fill: parent
        onClicked: {
            // Set target X coordinate and start the standalone animation
            standalone.to = mouseX;
            standalone.running = true;

            // Changing the y value will trigger
            // the behavioral animation of redRect below
            redRect.y = mouseY;
        }
    }

    Rectangle {
        id: redRect
        color: "red"
        width: 25
        height: 25

        // Behavioral animation doesn't need from, to or target parameters
        // Target is the owner, from and to come from the old and new property values
        Behavior on y { NumberAnimation { duration: 1000 } }
    }
}
