import Qt 4.7

Rectangle {

    id: rootRect;
    property double scaleClock: 1

    width: 200
    height: 200

    ClockRect {

        id: clockRect

        transform: Scale {
            origin { x: 0; y: 200 }
            yScale: rootRect.scaleClock
            xScale: 1
        }

        states: State {
            name: "scaled"
            when: mouseArea.pressed
            PropertyChanges {
                target: rootRect
                scaleClock: 0.8
            }
        }

        transitions: Transition {
            NumberAnimation { property: "scaleClock" }

        }
    }

    Text {
        width: parent.width
        height: 30
        x: 0; y: clockRect.state === "scaled" ? 10 : -30
        horizontalAlignment: Text.AlignHCenter
        verticalAlignment: Text.AlignVCenter
        wrapMode: Text.WordWrap
        text: new Date().toString()
        Behavior on y { NumberAnimation {} }
    }


    Timer {
        id: timer
        interval: 500
        running: true
        repeat: true
        onTriggered: {
            var d = new Date();
            clockRect.seconds = d.getSeconds();
            clockRect.minutes = d.getMinutes();
            clockRect.hours = d.getHours();
        }
    }

    MouseArea {
        id: mouseArea
        anchors.fill: parent
    }

}
