import Qt 4.7

Rectangle {
    id: rootRect

    // Initially this component is outside the parent's area
    // and only the grabber rectangle is visible. When state
    // changes to fullyVisible, x changes to 0
    x: 15 - width
    property bool fullyVisible: false

    // Relative position is slide area goes from 0 to 1
    // during slide.
    property real relativePosition: 0

    // Content area is currently empty
    Rectangle {
        id: content
        width: parent.width - 10
        x: 0; y: 0
    }

    // The grab-area (although, cannot be grabbed now)
    Rectangle {
        id: grabber
        width: 10
        radius: 3
        anchors.topMargin: 5
        anchors.bottomMargin: 5
        anchors.top: parent.top
        anchors.bottom: parent.bottom
        anchors.right: parent.right
        anchors.left: content.right
        border.width: 1
    }

    // Actually this would be better done with transform
    // instead of changing X.
    states: State {
        name: "full"
        when: rootRect.fullyVisible
        PropertyChanges {
            target: rootRect
            x: 0
            relativePosition: 1
        }
    }

    transitions: [
        Transition {
            NumberAnimation { properties: "x,relativePosition" }
        }
    ]

    // Mouse area covers the whole rectangle now as content is
    // empty. Should probably be changed to cover the grabber only.
    MouseArea {
        anchors.fill: parent
        onClicked: rootRect.fullyVisible = !rootRect.fullyVisible
    }
}
