import Qt 4.7

Rectangle {
    width: 200
    height: 200

    Flipable {
        id: flipText
        anchors.fill: parent

        // Flipped / not flipped flag is toggled by mouse area
        property bool flipped: false

        // Front and back sides have Item's each
        front: Text {
            text: "This is the front !!!"
            anchors.fill: parent
            verticalAlignment: Text.AlignVCenter
            horizontalAlignment: Text.AlignHCenter
        }
        back: Text {
            text: "This is the back !!!"
            anchors.fill: parent
            verticalAlignment: Text.AlignVCenter
            horizontalAlignment: Text.AlignHCenter
        }

        // Rotation tranform is required to see the back side
        // Note that the back side will not go upside-down even
        // if rotating via x-axis (try it)
        transform: Rotation {
            id: rotation;
            origin.x: flipText.width / 2;
            origin.y: flipText.height / 2
            axis.x: 0; axis.y: 1; axis.z: 0
        }

        // Back side has 180 degrees rotation angle
        states: State {
            name: "back"
            when: flipText.flipped
            PropertyChanges {
                target: rotation
                angle: 180
            }
        }

        // Flip is animated with NumberAnimation or RotationAnimation
        // depending on whether there's need to control the direction
        transitions: Transition {
            RotationAnimation {
                target: rotation
                direction: RotationAnimation.Clockwise
                property: "angle"
                duration: 600
            }
        }
    }

    MouseArea {
        anchors.fill: parent
        onClicked: flipText.flipped = !flipText.flipped
    }

}
