import Qt 4.7

Rectangle {
    width: 200
    height: 200

    // Rectangle, which can be dragged around
    // Note that anchors prevent dragging
    Rectangle {
        id: baseRect
        width: 100; height: 30; x: 50; y: 85
        border.color: "black"
        color: "lightblue"

        // Mouse area, which fills the rectangle and declares
        // it as draggable
        MouseArea {
            anchors.fill: parent
            drag.target: parent
            drag.maximumX: 100
            drag.minimumX: 0
            drag.maximumY: 170
            drag.minimumY: 0

            // Drag events are passed through nested mouse
            // areas to this one
            drag.filterChildren: true

            // MouseArea inherits Item, so may contain child items
            Text {
                id: helloText
                text: "Drag or Click!!!"
                anchors.fill: parent
                horizontalAlignment: Text.AlignHCenter
                verticalAlignment: Text.AlignVCenter

                // This fills text, text fills parent MouseArea,
                // which fills parent rectangle. Thus, this fills
                // the parent rectangle. Without drag.filterChildren
                // this MouseArea would block all mouse events
                MouseArea {
                    anchors.fill: parent
                    onClicked: baseRect.rotation += 180
                }
            }
        }
    }

}
