import Qt 4.7

Rectangle {
    width: 200
    height: 200

    Rectangle {
        id: redRect
        color: "red"
        width: 25
        height: 25
        transform: [
            // Example of combining rotations. One is constantly
            // running via property value source animation. Other
            // is bound to the x position of translation
            Rotation {
                angle: moved.x * 2
                origin { x: 12; y: 12 }
            },
            Rotation {
                origin { x: 12; y: 12 }
                RotationAnimation on angle {
                    loops: Animation.Infinite
                    from: 0; to: -360; duration: 5000
                }
            },
            Translate {
                id: moved
                x: 25; y: 25
                // Note: Compare with NumberAnimation
                // Compare velocity and duration
                Behavior on x {
                    // NumberAnimation { duration: 500 }
                    // SmoothedAnimation { duration: 500; velocity: -1 }
                    SmoothedAnimation { velocity: 100 }
                }
                Behavior on y {
                    // Note: Needs experimentation
                    SpringAnimation {
                        spring: 1;      // Strength of spring
                        damping: 0.05   // Amount of resistance
                        mass: 1.5       // Mass of the object
                    }
                }
            }
        ]
    }

    MouseArea {
        anchors.fill: parent
        onClicked: {
            // Subtract half of the rectangle
            moved.x = mouseX - 12.5
            moved.y = mouseY - 12.5
        }
    }
}
