import Qt 4.7
import "content"

Rectangle {
    width: 500
    height: 100

    // Loaded from "content" directory
    RedRect {

    }

    // An inline component is similar to a component
    // in separate file except that it doesn't have
    // a type name, so cannot be referenced directly
    // Loader needs to be used instead
    Component {
        id: helloComponent
        Text { text: "Loaded from: " + helloComponent.url }
    }

    // Loader inherits Item and the root Item of the loaded
    // component becomes a child of loader
    Loader {
        id: helloLoader
        sourceComponent: helloComponent
        x: (parent.width - width) / 2
        y: (parent.height - height) / 4
    }

    // Settings the sourceComponent to undefined value
    // destroys the component that was loaded.
    MouseArea {
        anchors.fill: parent
        onClicked: {
            if (!helloLoader.sourceComponent) {
                helloLoader.sourceComponent = helloComponent
            } else {
                helloLoader.sourceComponent = undefined
            }
        }
    }


    // Loader can also fetch QML components from web
    // Following example will fail as the server is down
    Loader {
        source: "http://tilli.homelinux.org/stuff/abc.qml"
        onStatusChanged: {
            switch (status) {
            case Loader.Error:
                console.log("Failed to load component...");
                break;
            case Loader.Ready:
                console.log("Component loaded...");
                break;
            case Loader.Loading:
                console.log("Component loading...");
                break;
            }
        }
    }

}
